HDOJ1518Square 深搜

简介: HDOJ1518Square 深搜

Square

Time Limit: 10000/5000 MS (Java/Others) Memory Limit: 65536/32768 K (Java/Others)

Total Submission(s): 11099 Accepted Submission(s): 3566


Problem Description

Given a set of sticks of various lengths, is it possible to join them end-to-end to form a square?


Input

The first line of input contains N, the number of test cases. Each test case begins with an integer 4 <= M <= 20, the number of sticks. M integers follow; each gives the length of a stick - an integer between 1 and 10,000.


Output

For each case, output a line containing “yes” if is is possible to form a square; otherwise output “no”.


Sample Input

3

4 1 1 1 1

5 10 20 30 40 50

8 1 7 2 6 4 4 3 5


Sample Output

yes

no

yes

题意就是:看这个数组中的数字组合是否能够构成一个正方形

不能分割数字,不能重复组合


代码:

#include<string.h>
#include<stdio.h>
#include<algorithm>
using namespace std;
int n,s,su,a[1010],vis[1010],len;
bool cmp(int a,int b)
{
    return a>b;//从大到小排序
}
void dfs(int a1,int a2,int a3)//(0,0,1)
{
    if(a1==3)/**只需要筹齐3次,那么剩下的一定能够成len长度**/
    {
        su=1;
        return ;
    }
    if(su==1)
        return ;/**优化时间**/
    for(int i=a3; i<=n; i++)
    {
  /**对于那些用过的和不符合条件的,for那里可以不扫,故从a3开始**/
   /**a3前面的对于最初的a2来说一定不符合**/
        if(vis[i]==0)
        {
            vis[i]=1;
            if(a2+a[i]==len)
            {
                dfs(a1+1,0,1);
                 /**但是换另外一条边的时候a3要改回1,因为那些未用的,对上一条边来说不符合条件的,可能符合这条边的条件**/
            }
            else if(a2+a[i]<len)
            {
                dfs(a1,a2+a[i],i+1);
                /**没筹齐从i+1继续,前面的不符合**/
                while(a[i]==a[i+1])
                    i++;
                    //回溯后如果后面的相同那么不需要再DFS
       //前面的数和后面的相同就可以跳过这个数,剪枝
            }
            vis[i]=0;
        }
    }
}
int main()
{
    int i;
    scanf("%d",&s);
    while(s--)
    {
        su=0;
        len=0;
        memset(vis,0,sizeof(vis));
        //memset函数在string.h头文件中
        scanf("%d",&n);
        for(i=1; i<=n; i++)
        {
            scanf("%d",&a[i]);
            len=len+a[i];
        }
        int mm=len/4;
        sort(a+1,a+n+1,cmp);
        //在algorithm头文件中
        if(len%4==0&&a[1]<=mm&&n>=4)
        {
            len/=4;
            dfs(0,0,1);
            if(su==1)
                printf("yes\n");
            else
                printf("no\n");
        }
        else
        {
            printf("no\n");
        }
    }
    return 0;
}
目录
相关文章
hdoj 4715 Difference Between Primes 素数筛选+二分查找
hdoj 4715 Difference Between Primes 素数筛选+二分查找
37 1
hdoj 1028/poj 2704 Pascal's Travels(记忆化搜索||dp)
有个小球,只能向右边或下边滚动,而且它下一步滚动的步数是它在当前点上的数字,如果是0表示进入一个死胡同。求它从左上角到右下角到路径数目。 注意, 题目给了提示了,要用64位的整数。
37 0
LeetCode 221. Maximal Square
在一个由 0 和 1 组成的二维矩阵内,找到只包含 1 的最大正方形,并返回其面积。
61 0
LeetCode 221. Maximal Square
HDOJ 1016 Prime Ring Problem素数环【深搜】
HDOJ 1016 Prime Ring Problem素数环【深搜】
117 0
HDOJ 1016 Prime Ring Problem素数环【深搜】
|
机器学习/深度学习
HDOJ 1334 Perfect Cubes(暴力)
HDOJ 1334 Perfect Cubes(暴力)
104 0
|
C语言
HDOJ/HDU Tempter of the Bone(深搜+奇偶性剪枝)
HDOJ/HDU Tempter of the Bone(深搜+奇偶性剪枝)
97 0
|
Go
HDOJ(HDU) 1977 Consecutive sum II(推导、、)
HDOJ(HDU) 1977 Consecutive sum II(推导、、)
107 0
|
机器学习/深度学习
HDOJ/HDU 1556 Color the ball(树状数组)
HDOJ/HDU 1556 Color the ball(树状数组)
102 0
|
C语言
HDOJ 1016 Prime Ring Problem素数环【深搜2】
HDOJ 1016 Prime Ring Problem素数环【深搜】
97 0
HDOJ(HDU) 2136 Largest prime factor(素数筛选)
HDOJ(HDU) 2136 Largest prime factor(素数筛选)
108 0